//+------------------------------------------------------------------+
//|                       MAIN INDICATOR                             |
//|                Fratelli Intraday trading system                  |
//|            http://www.forexfactory.com/showthread.php?t=325942   |
//|                                                                  |
//|it is an all in one combination of the following indicators:      |
//|                                              SuperTrend.mq4 v1.2 |
//|                   Copyright  2008, Jason Robinson (jnrtrading). |
//|                                   http://www.spreadtrade2win.com |
//|EMA-Crossover_Signal.mq4                                          |
//|         Copyright  2005, Jason Robinson (jnrtrading)            |
//|                   http://www.jnrtading.co.uk                     |
//|                                                                  |
//|                                                                  |
//|                                                MA_In_Color.mq4   |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//| Modified from LSMA_In_Color to use any MA by Robert Hill         |  
//|                                                                  |
//|  Combination made by MickyMouse , mihai27@seznam.cz              |
//|                                                                  |
//|     Repainting issue solved by McS                               |                                                             |
//|       Recoded by MCS                                             |
//|          Added trade buffers for ea use by MickyMouse            |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_color5 Blue
#property indicator_color6 Red

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3


int ATRPeriod = 10;
double Multiplier = 1.7;
extern int MaxBars = 300;
extern int NumberOfDays = 5;
// this is your broker's time
extern string Begin1 = "06:50";
extern string End1 = "17:00";
extern color  Clr1 = DarkGray;
extern color Color_2buy = Blue;
extern color Color_3sell = Yellow;
double wondering;
extern bool alertall=true;
double alertTag1;


 int CrossFastLwmaPeriod = 2;
 int CrossSlowLwmaPeriod = 15;

 int WickWidth = 1;
 int BodyWidth = 3;
 int MainEmaWidth = 1;
 color Color1 = Lime;
 color Color2 = Red;
 color Color3 = Lime;
 color Color4 = Red;

double Highs[];
double Lows[];
double Opens[];
double Closes[];
double MainEmaMacdUps[];
double MainEmaMacdDowns[];
double CrossLwmaUps[];
double CrossLwmaDowns[];
double siglev[];
double golong[];
double goshort[];

double point;

datetime CalcTime;
int changeOfTrend, start, i, prev_trend, trend;
double prev_up, prev_down, up, down, medianPrice, atr;
double MainEma, PrevMainEma, CrossFastLwma, PrevCrossFastLwma, CrossSlowLwma, PrevCrossSlowLwma, MacdFastEma, PrevMacdFastEma, MacdSlowEma, PrevMacdSlowEma;


int init()
{
  CalcTime = 0;

  point = Point;
  if (Digits % 2 == 1) point *= 10;
  
  IndicatorShortName("Fratelli_Main1.3");

  SetIndexStyle(0, DRAW_HISTOGRAM, 0, WickWidth, Color1);
  SetIndexBuffer(0, Lows);
  SetIndexStyle(1, DRAW_HISTOGRAM, 0, WickWidth, Color2);
  SetIndexBuffer(1, Highs);
  SetIndexStyle(2, DRAW_HISTOGRAM, 0, BodyWidth, Color3);
  SetIndexBuffer(2, Opens);
  SetIndexStyle(3, DRAW_HISTOGRAM, 0, BodyWidth, Color4);
  SetIndexBuffer(3, Closes);


  SetIndexStyle(4, DRAW_ARROW, EMPTY);
  SetIndexArrow(4, 233);
  SetIndexBuffer(4, CrossLwmaUps);
  SetIndexStyle(5, DRAW_ARROW, EMPTY);
  SetIndexArrow(5, 234);
  SetIndexBuffer(5, CrossLwmaDowns);
  SetIndexStyle(6, DRAW_NONE, EMPTY);
  SetIndexArrow(6, 1);
  SetIndexBuffer(6, golong);
  SetIndexStyle(7, DRAW_NONE, EMPTY);
  SetIndexArrow(7, 1);
  SetIndexBuffer(7, goshort);
  

  DeleteObjects();
  for (i = 0; i < NumberOfDays; i++) CreateObjects("PWT1" + i, Clr1);

  return(0);
}

int deinit()
{
  DeleteObjects();
  return(0);
}


void DeleteObjects()
{
  for (i = 0; i < NumberOfDays; i++) ObjectDelete("PWT1" + i);
}

void CreateObjects(string no, color cl)
{
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, True);
}

void DrawObjects(datetime dt, string no, string tb, string te)
{
  datetime t1, t2;
  double p1, p2;
  int b1, b2;

  t1 = StrToTime(TimeToStr(dt, TIME_DATE) + " " + tb);
  t2 = StrToTime(TimeToStr(dt, TIME_DATE) + " " + te);
  b1 = iBarShift(NULL, 0, t1);
  b2 = iBarShift(NULL, 0, t2);
  p1 = High[Highest(NULL, 0, MODE_HIGH, b1 - b2, b2)];
  p2 = Low[Lowest(NULL, 0, MODE_LOW , b1 - b2, b2)];
  //if (!HighRange) {p1=0; p2=2*p2;}
  ObjectSet(no, OBJPROP_TIME1 , t1);
  ObjectSet(no, OBJPROP_PRICE1, p1);
  ObjectSet(no, OBJPROP_TIME2 , t2);
  ObjectSet(no, OBJPROP_PRICE2, p2);
}

datetime decDateTradeDay (datetime dt)
{
  int ty = TimeYear(dt);
  int tm = TimeMonth(dt);
  int td = TimeDay(dt);
  int th = TimeHour(dt);
  int ti = TimeMinute(dt);

  td--;
  if (td==0)
  {
    tm--;
    if (tm ==0 )
    {
      ty--;
      tm = 12;
    }
    if (tm == 1 || tm == 3 || tm == 5 || tm == 7 || tm == 8 || tm == 10 || tm == 12) td = 31;
    if (tm == 2) if (((ty % 4 == 0) && (ty % 100 != 0)) || (ty % 400)) td = 29; else td = 28;
    if (tm == 4 || tm == 6 || tm == 9 || tm == 11) td = 30;
  }
  return(StrToTime(ty + "." + tm + "." + td + " " + th + ":" + ti));
}


double calcLwma(int start, int period)
{
  double lwma;
  
  lwma = 0.0;
  int j = 0;
  for (int k = start + period - 1; k >= start; k--)
  {
    j++;
    lwma += Close[k] * j;
  }
  lwma /= (j * (j + 1) / 2);
  
  return(lwma);
}

int start()
{  
  if (Bars <= MaxBars * 2) return(0);
  if (IndicatorCounted() < 0) return(-1);
double macd,ema89;
  if ((CalcTime == 0) || (Time[Bars - IndicatorCounted()] < CalcTime))
  {
    start = MaxBars * 2 - ATRPeriod + 1;
    MainEma = Close[start]; MacdFastEma = Close[start]; MacdSlowEma = Close[start];
    for (i = MaxBars * 2; i >= start - MaxBars; i--)
    {
      Highs[i] = EMPTY_VALUE;
      Lows[i] = EMPTY_VALUE;
      Opens[i] = EMPTY_VALUE;
      Closes[i] = EMPTY_VALUE;
      MainEmaMacdUps[i] = EMPTY_VALUE;
      MainEmaMacdDowns[i] = EMPTY_VALUE;
      CrossLwmaUps[i] = EMPTY_VALUE;
      CrossLwmaDowns[i] = EMPTY_VALUE;
    }
    up = Close[start]; down = Close[start];
    trend = 0;
    for(i = start - 1; i >= start - MaxBars; i--)
    {
      prev_up = up; prev_down = down; prev_trend = trend; PrevMainEma = MainEma; PrevMacdFastEma = MacdFastEma; PrevMacdSlowEma = MacdSlowEma;
      
      
      atr = iATR(NULL, 0, ATRPeriod, i);
      medianPrice = (High[i] + Low[i]) * 0.5;
      up = medianPrice + Multiplier * atr;
      
      down = medianPrice - Multiplier * atr;
      changeOfTrend = 0;

      if (Close[i] > prev_up)
      {
        trend = 1;
        
        
        if (prev_trend == -1) changeOfTrend = 1;
      }
      else if (Close[i] < prev_down)
      {
         trend = -1;
         if (prev_trend == 1) changeOfTrend = -1;
      }
      else trend = prev_trend;

      if (changeOfTrend == 0)
      {
        if (trend == 1 && down < prev_down) down = prev_down;
        if (trend == -1 && up > prev_up) up = prev_up;
      }      
    }
    CalcTime = Time[start - MaxBars];
    
  }

  start = iBarShift(NULL, 0, CalcTime); 
  up = prev_up; down = prev_down; MainEma = PrevMainEma; MacdFastEma = PrevMacdFastEma; MacdSlowEma = PrevMacdSlowEma;
  CrossFastLwma = calcLwma(start + 1, CrossFastLwmaPeriod); CrossSlowLwma = calcLwma(start + 1, CrossSlowLwmaPeriod);
  trend = prev_trend;
  for (i = start; i >= 0; i--)
  {
    prev_up = up; prev_down = down; prev_trend = trend; PrevMainEma = MainEma; PrevMacdFastEma = MacdFastEma; PrevMacdSlowEma = MacdSlowEma;
    PrevCrossFastLwma = CrossFastLwma; PrevCrossSlowLwma = CrossSlowLwma;
    
    
    
    CrossFastLwma = calcLwma(i, CrossFastLwmaPeriod);
    CrossSlowLwma = calcLwma(i, CrossSlowLwmaPeriod);
    if (i != 0)
    {
      if ((!(PrevCrossFastLwma > PrevCrossSlowLwma)) && (CrossFastLwma > CrossSlowLwma))
      {
        CrossLwmaUps[i] = Low[i] - 2.0 * point;
        
      }
      
      else CrossLwmaUps[i] = EMPTY_VALUE;
      if ((!(PrevCrossFastLwma < PrevCrossSlowLwma)) && (CrossFastLwma < CrossSlowLwma))
      {
        CrossLwmaDowns[i] = High[i] + 2.0 * point;
        
      }
      else CrossLwmaDowns[i] = EMPTY_VALUE;   
    }
    else {CrossLwmaUps[i] = EMPTY_VALUE; CrossLwmaDowns[i] = EMPTY_VALUE;}
    if (CrossLwmaUps[i+1] == Low[i+1] - 2.0 * point) {
      wondering = 1;
      }
      if (CrossLwmaDowns[i+1] == High[i+1] + 2.0 * point) {
      wondering = -1;
      }
    
    atr = iATR(NULL, 0, ATRPeriod, i);
    medianPrice = (High[i] + Low[i]) * 0.5;
    up = medianPrice + Multiplier * atr;
    siglev[i] = medianPrice + Multiplier * atr;
    down = medianPrice - Multiplier * atr;
    changeOfTrend = 0;
    macd= iMACD(NULL, NULL,12,26,9,PRICE_CLOSE,MODE_MAIN,i+1); 
    ema89 = iMA(NULL, NULL,89,0,MODE_EMA,PRICE_CLOSE,i+1);

    if (Close[i] > prev_up)
    {
      trend = 1;
      if (prev_trend == -1) changeOfTrend = 1;
    }
    else if (Close[i] < prev_down)
    {
       trend = -1;
       if (prev_trend == 1) changeOfTrend = -1;
    }
    else trend = prev_trend;

    if (changeOfTrend == 0)
    {
      if (trend == 1 && down < prev_down) down = prev_down;
      if (trend == -1 && up > prev_up) up = prev_up;
    }
    
    if (trend == 1)
    {
      
      Highs[i] = Low[i];
      Lows[i] = High[i];
      if (Open[i] > Close[i])
      {
        Opens[i] = Open[i];
        Closes[i] = Close[i];
      }
      else
      {
        Opens[i] = Close[i];
        Closes[i] = Open[i];
      }
    }
    else if (trend == -1)
    {
     
      Lows[i] = Low[i];
      Highs[i] = High[i];
      if (Open[i] > Close[i])
      {
        Closes[i] = Open[i];
        Opens[i] = Close[i];
      }
      else
      {
        Closes[i] = Close[i];
        Opens[i] = Open[i];
      }
     } 
      if ( Highs[i+1] == Low[i+1] && macd > 0 && Close[i+1] > ema89 && wondering == 1 ){
       
       
       
       golong[i] = (High[i+1]+40*Point);
       
     }
      if ( Highs[i+1] == High[i+1] && macd < 0 && Close[i+1] < ema89 && wondering == -1 ){
       
       
       
       goshort[i] = (Low[i+1]-30*Point);
       
     }
       
        if (alertall==true  && i == 1 && Highs[1] == Low[1] && iMACD(NULL, NULL,12,26,9,PRICE_CLOSE,MODE_MAIN,1) > 0 && Close[1] > iMA(NULL, NULL,89,0,MODE_EMA,PRICE_CLOSE,1) && wondering == 1 && alertTag1!=Time[0] ){
       Alert("BUY!!!All indicators line up",Symbol()," ",Period());
       alertTag1 = Time[0];
     }
     if (alertall==true  && i==1 && Highs[1] == High[1] && iMACD(NULL, NULL,12,26,9,PRICE_CLOSE,MODE_MAIN,1) < 0 && Close[1] < iMA(NULL, NULL,89,0,MODE_EMA,PRICE_CLOSE,1) && wondering == -1 && alertTag1!=Time[0] ){
       Alert("SELL!!! All indicators line up",Symbol()," ",Period());
       alertTag1 = Time[0];
       
         }    
          
         
         
    }
  
  
  
  CalcTime = Time[0];
  
  datetime dt = CurTime();

  for (i = 0; i < NumberOfDays; i++)
  {
    DrawObjects(dt, "PWT1" + i, Begin1, End1);
    dt = decDateTradeDay(dt);
    while (TimeDayOfWeek(dt) > 5) dt = decDateTradeDay(dt);
  }
  
  

  
  WindowRedraw();

  return(0);
}

